/*
One of those Weeks Episode 39: Snakes and Lawyers
Copyright (c) 2008,2011 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep39
{
	// Adobe Imports
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.events.Event;
	import flash.events.MouseEvent;

	// Blazing Games Imports
	import com.blazinggames.ootw.converse.*;

	public class OotW39Conversation
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

// ***** VARIABLES **********************************************************

		protected var _scriptHandler:DefaultScriptCommand;
		protected var _conversation:ConversationHandler;
		protected var _owner:OotW39;

// ***** CONSTRUCTOR ********************************************************

		public function OotW39Conversation()
		{
			_scriptHandler = new DefaultScriptCommand();
			_conversation = new ConversationHandler(speach_movie, _scriptHandler);
			speach_movie.clearDisplay();
			_conversation.addEventListener(Converse.TOPIC_EVENT, topicHandler);
			
			// create the conversation tree.
			var fs:String = "ISFLAGSET TRUE";
			_conversation.addTopic( ConversationHandler.EXIT_TOPIC);

			_conversation.addTopic( new ConversationTopic(
					"StartEp", "Start game", "Sssss ssss sssssss ssssss sssss? Garble garble garble garble garble? Can you hear me now?", 
					3,1, fs, null, new Array("English", "Haircut", "Translator", "Understand")));
			_conversation.addTopic( new ConversationTopic(
					"English", "You speak English?", "We have devices that allow us to translate different languages, even your primitive language. I am your legal representative though fear that the case is a lost cause.", 
					3,1, fs, new Array("SETFLAG ENGLISH"), new Array("Case", "Medusian", "SpaceStation")));
			_conversation.addTopic( new ConversationTopic(
					"Haircut", "I like your haircut!", "Your terminology does not translate properly though believe that you are referring to the fact that you are unfamiliar with the Medusian race. I am your  legal representative and will be helping you prepare for your trial.", 
					3,1, fs, null, new Array("Case", "Medusian", "SpaceStation")));
			_conversation.addTopic( new ConversationTopic(
					"Translator", "Wow! You have language translators! How do they work?", "You would have to talk to the professor about how the translator works. I am your legal representative though don't think you have much to worry about.", 
					3,1, fs, new Array("SETFLAG TRANSLATOR"), new Array("Case", "Medusian", "SpaceStation", "Professor")));
			_conversation.addTopic( new ConversationTopic(
					"Understand", "I can understand you.", "Good. The professors translator works. I am your legal representative and will be guiding you through your upcoming trial.", 
					3,1, fs, null, new Array("Case", "Medusian", "SpaceStation")));
			_conversation.addTopic( new ConversationTopic(
					"Case", "What case?", "You will be shortly going in front of a judge to determine if you should be treated as an intelligent life form or as the Cantriever's pet. The rules for this space station do not allow for large pets so if you are deemed to be a pet you will have to be put to sleep.", 
					3,1, fs, null, new Array("Sleep", "Intelligent", "Appeal", "Judge", "Work")));
			_conversation.addTopic( new ConversationTopic(
					"Medusian", "What are you?", "We are an older race than yours who have in fact sent explorers to your world a few thousand years ago. Unfortunately your race was still highly superstitious at that time and beheaded our ambassador. Perhaps the statues we created as a gift was interpreted the wrong way?", 
					3,1, fs, new Array("SETFLAG MEDUSIAN"), new Array("Case", "SpaceStation")));
			_conversation.addTopic( new ConversationTopic(
					"SpaceStation", "Where exactly am I?", "You are on a remote research station. The professor is in charge of a number of highly dangerous research projects but do not worry, all the basic amenities are available as there are a lot of people who like the extra time credit that working in such a danger area provides.", 
					3,1, fs, new Array("SETFLAG SPACESTATION"), new Array("Credits", "Danger", "Professor")));
			_conversation.addTopic( new ConversationTopic(
					"Professor", "Any chance of me meeting this professor?", "Well, the professor has been asking for a personal assistants so if you are not in fact a pet then we will probably assign you, your damaged companion, and the Cantriever to aid him. The furry thing is small enough that we will allow it to remain on board as a pet.", 
					3,1, fs, new Array("SETFLAG PROFESSOR"), new Array("Case", "Medusian", "SpaceStation")));
			_conversation.addTopic( new ConversationTopic(
					"Sleep", "I could use a nap!", "Perhaps this is a hopeless case. I  don't think you can handle any details about our justice system so simply try to answer all the judges questions.", 
					3,1, fs, new Array("SETFLAG SLEEP"), new Array("OVER")));
			_conversation.addTopic( new ConversationTopic(
					"Intelligent", "How do you determine if I am an intelligent life form?", "Our rules are fairly simple. Our species considers another species to be intelligent once they are able to show knowledge of their own solar system. If you prove to know sufficient knowledge, you will be considered intelligent enough to earn citizenship.", 
					3,1, fs, new Array("SETFLAG INTELLIGENT"), new Array("Appeal", "Judge", "Work", "OVER")));
			_conversation.addTopic( new ConversationTopic(
					"Appeal", "If I lose can I appeal?", "Our proceedings are automatically reviewed by judges in different parts of our territory while the proceedings are taking place so there is rarely a need for an appeal and since you are not a citizen an appeal is doubtful.", 
					3,1, fs, new Array("SETFLAG APPEAL"), new Array("Intelligent", "Judge", "Work", "OVER")));
			_conversation.addTopic( new ConversationTopic(
					"Judge", "Who judges me?", "Your Judge will be the only Judge at this space station, Judge Sussith. She usually covers petty cases, but don't worry, there will be two other judges monitoring the proceedings remotely with the ability to intervene if necessary.", 
					3,1, fs, null, new Array("Intelligent", "Appeal", "Work", "OVER")));
			_conversation.addTopic( new ConversationTopic(
					"Work", "What happens if I win?", "As you are not a citizen, you must first put in enough hours to purchase citizenship. Thankfully the professor is in needs of assistants and as it is highly dangerous work you will earn a lot of hour credits.", 
					3,1, fs, null, new Array("Intelligent", "Appeal", "Judge", "OVER")));
			_conversation.addTopic( new ConversationTopic(
					"Credits",  "Time credits?", "Our society revolves around the simple concept that time is money. Working earns time credits. The amount of credits is based on the actual skill required to do the job, the skill level of the person doing the work, and the danger involved.",
					3,1, fs, new Array("SETFLAG CREDITS"), new Array("Case", "Medusian", "SpaceStation", "Danger")));
			_conversation.addTopic( new ConversationTopic(
					"Danger", "How dangerous is it?", "As we are on the maximum danger level for research stations, all jobs here pay a large bonus in time credits due to the potential danger. The professor is experimenting with dimensional manipulation which could possibly cause the entire space station to be destroyed, but the professor is brilliant so I am not worried.", 
					3,1, fs, null, new Array("Case", "Medusian", "SpaceStation", "Credits")));
			_conversation.addTopic( new ConversationTopic(
					"OVER", "Okay I'm ready for trial", "This should be taking you to the end sequence.", 
					3,1, fs, null, new Array("Exit")));

/*
SCORING
* English *{ score - 1}
* Translator *{ Score + 1 }
* Medusian *{ Score + 1 }
* SpaceStation *{ Score + 1 }
* Professor * {Score +1}
* Sleep * { Score - 1}
*  Intelligent *{ score + 1}
*  Appeal * {score + 1)
* Credits {score + 1}

*/

		}

// *****

		function topicHandler(event:Event):void {
			var top:ConversationTopic = _conversation.getLastTopic();
			trace(top.topic + "topic was selected");

			if ((top.topic == "Exit") || (top.topic == "OVER")) {
				_owner.toScore();
			/*} else if (top.topic == "Home") {
				_owner.toPark();
			}*/
			} else {
				_conversation.showTopic(top.topic);
			}
		}

// ***** Functions - General control ****************************************

		public function showTopic(s:String, owner:OotW39)
		{
			_conversation.showTopic(s);
			_owner = owner;
		}
		
		public function resetConversation():void
		{
			_scriptHandler.parseCommand("CLEARFLAG ENGLISH");
			_scriptHandler.parseCommand("CLEARFLAG TRANSLATOR");
			_scriptHandler.parseCommand("CLEARFLAG MEDUSIAN");
			_scriptHandler.parseCommand("CLEARFLAG SPACESTATION");
			_scriptHandler.parseCommand("CLEARFLAG PROFESSOR");
			_scriptHandler.parseCommand("CLEARFLAG SLEEP");
			_scriptHandler.parseCommand("CLEARFLAG INTELLIGENT");
			_scriptHandler.parseCommand("CLEARFLAG APPEAL");
			_scriptHandler.parseCommand("CLEARFLAG CREDITS");
		}
		
		public function scoreConversation():int
		{
			var score:int = 0;
			if (_scriptHandler.parseQuery("ISFLAGSET ENGLISH"))
				--score;
			if (_scriptHandler.parseQuery("ISFLAGSET TRANSLATOR"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET MEDUSIAN"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET SPACESTATION"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET PROFESSOR"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET SLEEP"))
				--score;
			if (_scriptHandler.parseQuery("ISFLAGSET INTELLIGENT"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET APPEAL"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET CREDITS"))				
				++score;
				
			return score;
		}
	} // end class
} // end package

